#ifndef ZLS_GRAPH_H
#define ZLS_GRAPH_H
#include "zls.h"

int zlsg_Reset            (void);

int zlsg_SetImage8        ( UInt8   * img, int nxOut, int nyOut );
int zlsg_SetImage16       ( UInt16  * img, int nxOut, int nyOut );

int zlsg_SetImage8RGB     ( UInt8   * imgR, UInt8   * imgG, UInt8   * imgB, int nxOut, int nyOut );
int zlsg_SetImage16RGB    ( UInt16  * imgR, UInt16  * imgG, UInt16  * imgB, int nxOut, int nyOut );

int SetPixelValue         ( int i, int j, float v); // v = 0.0F- 1.0F
int SetPixelInteger       ( int i, int j, Integer idx); // idx = 0-255 for 8bit, 0-65535 U16, 0-32676 S16
int DrawPixel             ( int i, int j );
int DrawVisiblePixel      ( int i, int j);

int zlsg_DrawChar         ( int i, int j, char c );
int zlsg_DrawString       ( int i, int j, char * c );

int zlsg_DrawLine         ( int i1, int j1, int i2, int j2 );
int zlsg_DrawBar          ( int i1, int j1, int i2, int j2 );
int zlsg_ClearRect        ( int i1, int j1, int i2, int j2 );

int zlsg_FrameRect        ( int i1, int j1, int i2, int j2);

#endif ZLS_GRAPH_H
