#ifndef ZLS_IOIMAGES_H
#define ZLS_IOIMAGES_H
#include "zls.h"

enum {  kAllowCompressedOutput   = 0x00,  // permit gzip compression if zlib is enabled, not otherwise
  kUnCompressedOutput  = 0x01,   // never gzip compression, even if zlib is enabled
};

int zlsio_ScaleAndWritePlot  ( char * fname, IOSettingsPtr io, Integer ioIndex, Integer nxOut, Integer nyOut, Integer dim, Integer compressOption);
//
// low level save an io variable as a 2D image file
//
int zlsio_ScaleAndWriteImage ( char * fname, IOSettingsPtr io, Integer ioIndex, Integer nxOut, Integer nyOut, Integer dim, Integer compressOption );
//
// high level save a zone variable as a 1D plot or 2D image file, slicing or summing as needed in 2D/3D
//
int zlsio_SaveZoneImage      ( ZonePtr z, Integer varIndex, Integer level, Integer zone,
                              IOSettingsPtr  io, Integer ioIndex ) ;
//
// high level save an enire level of zones as a 2D image file, merged (0) or separtely, summing as needed in 3D
//
int zlsio_SaveLevelImages       ( Integer level, int step );
//
// as above without multi-zone merging
//
int zlsio_SaveSimpleLevelImages ( Integer level, int step); // images are all 2D, even if just barely (ie a single row for 1D input)

#endif ZLS_IOIMAGES_H
