#ifndef ZLS_JPEGIO_H
#define ZLS_JPEGIO_H

#include <zls.h>
#include <jpeglib.h>

//========================================
//
// JPEG File IO Routines
//
//========================================
// These all write jpegs of 24 bit images, the 8 bit version has RGB
// values computed on the fly These only work for 8 bits per channel
// data.  Use tiffio for 16bit per channel image output

int zls_Write_jpeg8    (char * aFile, UInt8  * img, TIFFCTab * outTIFFCTab, int nxOut, int nyOut );   // 8 bit tiff colour table, use gray ctab for grayscale
int zls_Write_jpegRGB  (char * aFile, UInt8  * imgR, UInt8   * imgG,  UInt8   * imgB, int nxOut, int nyOut ); // normal 8 bit per channel RGB, no ctab

#endif ZLS_JPEGIO_H
