#include <zls.h>

//
//========================================
//
//
// Primitive/Physical variable arrays:
//
//
//========================================

int zlsh_PrintW1D(W1DArr w, Integer cellIndex){ // cellIndex = -1 for whole array
	
	int err = noErr;
	Integer    i;
	Var1       v;
	
	if (w.d != NULL){
		
		if (cellIndex>=0) {
			
			zlsio_Printf( " Primitive Variable Array Element: %d\n", cellIndex);
			zlsio_Printf( " ######################################\n" );
			zlsio_Printf( " Array: N %4d NS %4d NE %4d NT %4d \n", w.n, w.ns, w.ne, w.nt );
			
#ifdef PPM
			SLRQ1 vlr = w.cs[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f\n",cellIndex ,"cs",
                    vlr.a, vlr.al, vlr.ar );
			
#ifdef VARIABLE_GAMMA
      vlr = w.g[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f\n",cellIndex ,"g ",
                    vlr.a, vlr.al, vlr.ar );
#endif VARIABLE_GAMMA
			
			v = w.d[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f del%8.4f a6%8.4f\n",cellIndex ,"d",
				   v.a, v.al, v.ar, v.del, v.a6 );
			
			v = w.P[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f del%8.4f a6%8.4f\n",cellIndex ,"P",
				   v.a, v.al, v.ar, v.del, v.a6 );
			

			v = w.E[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f del%8.4f a6%8.4f\n",cellIndex ,"E",
				   v.a, v.al, v.ar, v.del, v.a6 );

			
			v = w.vx[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f del%8.4f a6%8.4f\n",cellIndex ,"vx",
				   v.a, v.al, v.ar, v.del, v.a6 );
			
#if (NTRACERS > 0)  
			for (i = 0; i< kNTracers; i++){
				v = w.tr[i][cellIndex];
				zlsio_Printf( " Index %4d %s %d: a%8.4f al%8.4f ar%8.4f del%8.4f a6%8.4f\n",cellIndex ,"tr", i,
					   v.a, v.al, v.ar, v.del, v.a6 );
			}
#endif
      
#endif PPM
      
#ifdef PLM
			v = w.cs[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f del%8.4f \n",cellIndex ,"cs",
                    v.a, v.al, v.ar );
			
			v = w.d[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f del%8.4f \n",cellIndex ,"d",
                    v.a, v.al, v.ar );
			
			v = w.P[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f del%8.4f \n",cellIndex ,"P",
                    v.a, v.al, v.ar );
			

			v = w.E[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f \n",cellIndex ,"E",
                    v.a, v.al, v.ar );

			
			v = w.vx[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f al%8.4f ar%8.4f \n",cellIndex ,"vx",
                    v.a, v.al, v.ar );
			
#if (NTRACERS > 0)  
			for (i = 0; i< kNTracers; i++){
				v = w.tr[i][cellIndex];
				zlsio_Printf( " Index %4d %s %d: a%8.4f al%8.4f ar%8.4f \n",cellIndex ,"tr", i,
                      v.a, v.al, v.ar );
			}
			
#endif
     
#endif PLM
      
#ifdef GODUNOV
			SLRQ1 vlr = w.cs[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f \n",cellIndex ,"cs",
                    vlr.a );
			
			SLRQ1 vlr = w.g [cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f \n",cellIndex ,"g ",
                    vlr.a );
			
			v = w.d[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f \n",cellIndex ,"d",
                    v.a );
			
			v = w.P[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f \n",cellIndex ,"P",
                    v.a );
			

			v = w.E[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f \n",cellIndex ,"E",
                    v.a );

			
			v = w.vx[cellIndex];
			zlsio_Printf( " Index %4d %s: a%8.4f \n",cellIndex ,"vx",
                    v.a );
			
#if (NTRACERS > 0)  
			for (i = 0; i< kNTracers; i++){
				v = w.tr[i][cellIndex];
				zlsio_Printf( " Index %4d %s %d: a%8.4f \n",cellIndex ,"tr", i,
                      v.a );
			}
			
#endif
      
#endif GODUNOV
			
		} else { // loop whole array , could be big!
			for (i = 0; w.nt; i++) {
				zlsh_PrintW1D(w, i);
			}
		}
		
	}else { err = memErr;}
	
	return (err);
}

int zlsh_ListW1D(W1DArr w, Integer cellIndex){ // cellIndex = -1 for whole array
	
	int err = noErr;
	Integer    i;
	
	if (w.d != NULL){
		
		if (cellIndex>=0) {
			
			zlsio_Printf( "  N  Density  Pressure Velocity  Total Energy  Sound Speed \n" );
			for (i = 0; w.nt; i++) {
				zlsio_Printf( " %4d %10.5g %10.5g %10.5g %10.5g %10.5g \n",cellIndex ,
					   w.d[cellIndex].a, w.P[cellIndex].a, w.vx[cellIndex].a,  w.E[cellIndex].a,  w.cs[cellIndex].a );
			}
			
		} else { // loop whole array , could be big!
			
			zlsio_Printf( "  N  Density  Pressure Velocity  Total Energy  Sound Speed \n" );
			for (i = 0; i< w.nt; i++) {
				zlsio_Printf( " %4d %10.5g %10.5g %10.5g %10.5g %10.5g \n",i ,
					   w.d[i].a, w.P[i].a, w.vx[i].a,  w.E[i].a,  w.cs[i].a );
			}
			
		}
		
	}else { err = memErr;}
	
	return (err);
}


int zlsh_ClearW1DArr(W1DArr *w){
	
	int err = noErr;
	
	w->n  = 0;
	w->ns = 0;
	w->ne = 0;
	w->nt = 0;
	
	w->x = NULL;  // get an axis from an owning grid
	
	w->flat      = NULL;
#ifdef DIVVHCORRECTION
	w->divv      =  NULL;
#endif DIVVHCORRECTION
  
	w->cs =  NULL;
#ifdef VARIABLE_GAMMA
	w->g  =  NULL;
#endif VARIABLE_GAMMA
	
	w->d  = NULL;
	w->P  = NULL;

	w->E  = NULL;
	  
#ifdef HYDRO
#ifdef SYM1D
	w->vx = NULL;
#endif SYM1D
	
#ifdef SYM2D
	w->vx = NULL;
	w->vy = NULL;
#endif SYM2D
	
#ifdef SYM3D
	w->vx = NULL;
	w->vy = NULL;
	w->vz = NULL;
#endif SYM3D
#endif HYDRO

  
#if (NTRACERS > 0)  
	Integer i;
	for (i = 0; i< kNTracers; i++){
		w->tr[i]  = NULL;
	}
#endif

	return(err);
	
}

int zlsh_NewW1DArr(W1DArr *w, Integer nBC, Counter ni){
	
	int err = noErr;
	
	w->n  = ni;
	w->ns = nBC;
	w->ne = nBC+ni;
	w->nt = nBC+nBC+ni;
	
	w->x = NULL;  // get an axis from an owning grid
	
	w->flat      = (Real*) malloc((nBC+nBC+ni)*sizeof(Real));
#ifdef DIVVHCORRECTION
	w->divv      = (Real*) malloc((nBC+nBC+ni)*sizeof(Real));
#endif DIVVHCORRECTION
  
	w->cs = (SLRQ1*) malloc((nBC+nBC+ni)*sizeof(SLRQ1));
#ifdef VARIABLE_GAMMA
	w->g  = (SLRQ1*) malloc((nBC+nBC+ni)*sizeof(SLRQ1));
#endif VARIABLE_GAMMA
	
	w->d  = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
	w->P  = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
	w->E  = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
#ifdef HYDRO
#ifdef SYM1D
	w->vx = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
#endif SYM1D
	
#ifdef SYM2D
	w->vx = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
	w->vy = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
#endif SYM2D
	
#ifdef SYM3D
	w->vx = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
	w->vy = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
	w->vz = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
#endif SYM3D  
#endif HYDRO
    
#if (NTRACERS > 0)  
	Integer i;
	for (i = 0; i< kNTracers; i++){
		w->tr[i]  = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));
	}
#endif
  
  
	if (w->P == NULL) {
		err = memErr;
	}
	
	return(err);
	
}


int zlsh_ClearW2DArr(W2DArr *w){
	
	int err = noErr;
	
	w->n [0] = 0;
	w->n [1] = 0;
	w->ns[0] = 0;
	w->ns[1] = 0;
	w->ne[0] = 0;
	w->ne[1] = 0;
	w->nt[0] = 0;
	w->nt[1] = 0;
	
	w->x = NULL;  // get an axis from an owning grid
	w->y = NULL;  // get an axis from an owning grid

	w->flat      = NULL;
#ifdef DIVVHCORRECTION
	w->divv      =  NULL;
#endif DIVVHCORRECTION
  
	w->cs =  NULL;
#ifdef VARIABLE_GAMMA
	w->g  =  NULL;
#endif VARIABLE_GAMMA
	
	w->d  = NULL;
	w->P  = NULL;
	w->E  = NULL;
	
#ifdef HYDRO
#ifdef SYM1D
	w->vx = NULL;
#endif SYM1D
	
#ifdef SYM2D
	w->vx = NULL;
	w->vy = NULL;
#endif SYM2D
	
#ifdef SYM3D
	w->vx = NULL;
	w->vy = NULL;
	w->vz = NULL;
#endif SYM3D
#endif HYDRO
  
  
#if (NTRACERS > 0)  
	Integer i;
	for (i = 0; i< kNTracers; i++){
		w->tr[i]  = NULL;
	}
#endif
  
	return(err);
	
}


int zlsh_NewW2DArr(W2DArr *w, Integer nBC, Counter nj, Counter ni){
	
	int err = noErr;
	
	w->n[kXDim] = ni;
	w->ns[kXDim] = nBC;
	w->ne[kXDim] = nBC+ni;
	w->nt[kXDim] = nBC+nBC+ni;
	w->x = NULL;  // get an axis from an owning grid
	
	w->n[kYDim] = nj;
	w->ns[kYDim] = nBC;
	w->ne[kYDim] = nBC+nj;
	w->nt[kYDim] = nBC+nBC+nj;
	w->y = NULL;  // get an axis from an owning grid
	
	w->flat      = (Real**) zlsAlloc2DArr(  sizeof(Real), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#ifdef DIVVHCORRECTION
	w->divv      = (Real**) zlsAlloc2DArr(  sizeof(Real), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif DIVVHCORRECTION

	w->cs   = (SLRQ2**) zlsAlloc2DArr(sizeof(SLRQ2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#ifdef VARIABLE_GAMMA
	w->g    = (SLRQ2**) zlsAlloc2DArr(sizeof(SLRQ2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif VARIABLE_GAMMA
	
	w->d  = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->P  = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->E  = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	
#ifdef HYDRO
#ifdef SYM1D
	w->vx = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif SYM1D
	
#ifdef SYM2D
	w->vx = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->vy = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif SYM2D
	
#ifdef SYM3D
	w->vx = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->vy = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->vz = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif SYM3D
#endif HYDRO
  
#if (NTRACERS > 0)    
	Integer i;
	for (i = 0; i< kNTracers; i++){
		w->tr[i]  = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	}
#endif
	
	if (w->P == NULL) {
		err = memErr;
	}
	
	return(err);
}


int zlsh_ClearW3DArr(W3DArr * w){
	
	int err = noErr;
	
	w->n [0] = 0;
	w->n [1] = 0;
	w->n [2] = 0;
	w->ns[0] = 0;
	w->ns[1] = 0;
	w->ns[2] = 0;
	w->ne[0] = 0;
	w->ne[1] = 0;
	w->ne[2] = 0;
	w->nt[0] = 0;
	w->nt[1] = 0;
	w->nt[2] = 0;
	
	w->x = NULL;  // get an axis from an owning grid
	w->y = NULL;  // get an axis from an owning grid
	w->z = NULL;  // get an axis from an owning grid

	w->flat      = NULL;
#ifdef DIVVHCORRECTION
	w->divv      =  NULL;
#endif DIVVHCORRECTION
  
	w->cs =  NULL;
#ifdef VARIABLE_GAMMA
	w->g  =  NULL;
#endif VARIABLE_GAMMA
	
	w->d  = NULL;
	w->P  = NULL;
	w->E  = NULL;
	
#ifdef HYDRO
#ifdef SYM1D
	w->vx = NULL;
#endif SYM1D
	
#ifdef SYM2D
	w->vx = NULL;
	w->vy = NULL;
#endif SYM2D
	
#ifdef SYM3D
	w->vx = NULL;
	w->vy = NULL;
	w->vz = NULL;
#endif SYM3D
#endif HYDRO
  
#if (NTRACERS > 0)  
	Integer i;
	for (i = 0; i< kNTracers; i++){
		w->tr[i]  = NULL;
	}
#endif
  
	return(err);
	
}

int zlsh_NewW3DArr(W3DArr *w, Integer nBC, Counter nk, Counter nj, Counter ni){
	
	int err = noErr;
	
	w->n[kXDim] = ni;
	w->ns[kXDim] = nBC;
	w->ne[kXDim] = nBC+ni;
	w->nt[kXDim] = nBC+nBC+ni;
	w->x = NULL;  // get an axis from an owning grid
	w->n[kYDim] = nj;
	w->ns[kYDim] = nBC;
	w->ne[kYDim] = nBC+nj;
	w->nt[kYDim] = nBC+nBC+nj;
	w->y = NULL;  // get an axis from an owning grid
	w->n[kZDim] = nk;
	w->ns[kZDim] = nBC;
	w->ne[kZDim] = nBC+nk;
	w->nt[kZDim] = nBC+nBC+nk;
	w->z = NULL;  // get an axis from an owning grid
	
	w->flat       = (Real***) zlsAlloc3DArr(  sizeof(Real), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#ifdef DIVVHCORRECTION
	w->divv       = (Real***) zlsAlloc3DArr(  sizeof(Real), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif DIVVHCORRECTION

	w->cs    = (SLRQ3***) zlsAlloc3DArr(sizeof(SLRQ3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#ifdef VARIABLE_GAMMA
	w->g     = (SLRQ3***) zlsAlloc3DArr(sizeof(SLRQ3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif VARIABLE_GAMMA
	
	w->d     = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->P     = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->E     = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);

  
#ifdef HYDRO
#ifdef SYM1D
  w->vx = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif SYM1D
  
#ifdef SYM2D
  w->vx = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->vy = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif SYM2D
  
#ifdef SYM3D
  w->vx = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->vy = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	w->vz = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
#endif SYM3D
#endif HYDRO

#if (NTRACERS > 0)    
	Integer i;
	for (i = 0; i< kNTracers; i++){
		w->tr[i]  = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)w->nt[kZDim], (Counter)w->nt[kYDim], (Counter)w->nt[kXDim]);
	}
#endif
	
	if (w->vx == NULL) {
		err = memErr;
	}
	
	return(err);
}

int zlsh_DisposeW1DArr  (W1DArr w){
	int err = noErr;
	
	if (w.flat      !=NULL) free((void *)w.flat); w.flat = NULL;
#ifdef DIVVHCORRECTION
	if (w.divv      !=NULL) free((void *)w.divv); w.divv = NULL;
#endif DIVVHCORRECTION
  
	if (w.cs !=NULL) free((void *)w.cs); w.cs = NULL;

#ifdef VARIABLE_GAMMA
	if (w.g  !=NULL) free((void *)w.g ); w.g  = NULL;
#endif VARIABLE_GAMMA
	
	if (w.d !=NULL) free((void *)w.d); w.d = NULL;
	if (w.P !=NULL) free((void *)w.P); w.P = NULL;
	if (w.E !=NULL) free((void *)w.E); w.E = NULL;
  
#ifdef HYDRO
#ifdef SYM1D
	if (w.vx !=NULL) free((void *)w.vx); w.vx = NULL;
#endif SYM1D
	
#ifdef SYM2D
	if (w.vx !=NULL) free((void *)w.vx); w.vx = NULL;
	if (w.vy !=NULL) free((void *)w.vy); w.vy = NULL;
#endif SYM2D
	
#ifdef SYM3D
	if (w.vx !=NULL) free((void *)w.vx); w.vx = NULL;
	if (w.vy !=NULL) free((void *)w.vy); w.vy = NULL;
	if (w.vz !=NULL) free((void *)w.vz); w.vz = NULL;
#endif SYM3D
#endif HYDRO
	
#if (NTRACERS > 0)    
	Integer i;
	for (i = 0; i< kNTracers; i++){
		if (w.tr[i] !=NULL) free((void *)w.tr[i]); w.tr[i] = NULL;
	}
#endif
	return(err);
}

int zlsh_DisposeW2DArr  (W2DArr w){
	int err = noErr;
	
	if (w.flat      !=NULL) zlsFree2DArr((void **)w.flat); w.flat = NULL;
#ifdef DIVVHCORRECTION
	if (w.divv      !=NULL) zlsFree2DArr((void **)w.divv); w.divv = NULL;
#endif DIVVHCORRECTION
  
	if (w.cs !=NULL) zlsFree2DArr((void **)w.cs); w.cs = NULL;
#ifdef VARIABLE_GAMMA
	if (w.g  !=NULL) zlsFree2DArr((void **)w.g ); w.g  = NULL;
#endif VARIABLE_GAMMA
	
	if (w.d !=NULL) zlsFree2DArr((void **)w.d); w.d = NULL;
	if (w.P !=NULL) zlsFree2DArr((void **)w.P); w.P = NULL;
	if (w.E !=NULL) zlsFree2DArr((void **)w.E); w.E = NULL;
		
  
#ifdef HYDRO
#ifdef SYM1D
	if (w.vx !=NULL) zlsFree2DArr((void **)w.vx); w.vx = NULL;
#endif SYM1D
#ifdef SYM2D
	if (w.vx !=NULL) zlsFree2DArr((void **)w.vx); w.vx = NULL;
	if (w.vy !=NULL) zlsFree2DArr((void **)w.vy); w.vy = NULL;
#endif SYM2D
#ifdef SYM3D
	if (w.vx !=NULL) zlsFree2DArr((void **)w.vx); w.vx = NULL;
	if (w.vy !=NULL) zlsFree2DArr((void **)w.vy); w.vy = NULL;
	if (w.vz !=NULL) zlsFree2DArr((void **)w.vz); w.vz = NULL;
#endif SYM3D
#endif HYDRO
  
#if (NTRACERS > 0)    
	Integer i;
	for (i = 0; i< kNTracers; i++){
		if (w.tr[i] != NULL)  zlsFree2DArr((void **)w.tr[i]);
		w.tr[i] = NULL;
	}
#endif
	
	return(err);
}

int zlsh_DisposeW3DArr  (W3DArr w){
	int err = noErr;
	
	if (w.flat      !=NULL) zlsFree3DArr((void ***)w.flat); w.flat = NULL;
#ifdef DIVVHCORRECTION
	if (w.divv      !=NULL) zlsFree3DArr((void ***)w.divv); w.divv = NULL;
#endif DIVVHCORRECTION

	if (w.cs !=NULL) zlsFree3DArr((void ***)w.cs); w.cs = NULL;
#ifdef VARIABLE_GAMMA
	if (w.g  !=NULL) zlsFree3DArr((void ***)w.g ); w.g  = NULL;
#endif VARIABLE_GAMMA
	
	if (w.d !=NULL) zlsFree3DArr((void ***)w.d); w.d = NULL;
	if (w.P !=NULL) zlsFree3DArr((void ***)w.P); w.P = NULL;
	if (w.E !=NULL) zlsFree3DArr((void ***)w.E); w.E = NULL;
	
#ifdef HYDRO
#ifdef SYM1D
	if (w.vx !=NULL) zlsFree3DArr((void ***)w.vx); w.vx = NULL;
#endif SYM1D
#ifdef SYM2D
	if (w.vx !=NULL) zlsFree3DArr((void ***)w.vx); w.vx = NULL;
	if (w.vy !=NULL) zlsFree3DArr((void ***)w.vy); w.vy = NULL;
#endif SYM2D
#ifdef SYM3D
	if (w.vx !=NULL) zlsFree3DArr((void ***)w.vx); w.vx = NULL;
	if (w.vy !=NULL) zlsFree3DArr((void ***)w.vy); w.vy = NULL;
	if (w.vz !=NULL) zlsFree3DArr((void ***)w.vz); w.vz = NULL;
#endif SYM3D
#endif HYDRO
  
#if (NTRACERS > 0)    
	Integer i;
	for (i = 0; i< kNTracers; i++){
		if (w.tr[i] !=NULL) zlsFree3DArr((void ***)w.tr[i]); w.tr[i] = NULL;
	}
#endif

	return(err);
}

int zlsh_SetVar1DFromW1D(V1DArr v, W1DArr w, Integer varIndex){
	// set a V1DArr from a W1DArr ready for calc coeffs etc
	// fast because it simply copies references, so don't dispose the var
	// afterwards.
#if (NTRACERS > 0)
  Integer trindex = (varIndex-kTracer0);
#endif
	int err = noErr;
	v.n = w.n;
	v.ns = w.ns;
	v.ne = w.ne;
	v.nt = w.nt;
	v.x = w.x;
	
	if ((varIndex>=0)&&(varIndex<kNAllVars)){
		
		switch (varIndex) {
			case kWDens:
				v.v = w.d;
				break;
			case kWPres:
				v.v = w.P;
				break;
			case kWVx:
				v.v = w.vx;
				break;
#if (NDIMS>1)
			case kWVy:
				v.v = w.vy;
				break;
#if  (NDIMS>2)
			case kWVz:
				v.v = w.vz;
				break;
#endif SYM3D
#endif SYM2D
			default:
        ;
#if (NTRACERS > 0)
        if ((trindex < kNTracers)&&(trindex>=0)) {
          v.v = w.tr[trindex]; // tracer vars
        }
#endif
        
		}
    
	}
	
  return(err);

}


int zlsh_NewF1DArr(F1DArr *f, Integer nBC, Counter ni){
	
	int err = noErr;
	
	f->n  = ni;
	f->ns = nBC;
	f->ne = nBC+ni;
	f->nt = nBC+nBC+ni;
	
	f->x = NULL;  // get an axis from an owning grid
		
	f->xi = (Var1*) malloc((nBC+nBC+ni)*sizeof(Var1));

	if (f->xi == NULL) {
		err = memErr;
	}
	
	return(err);
	
}

int zlsh_NewF2DArr(F2DArr *f, Integer nBC, Counter nj, Counter ni){
	
	int err = noErr;
	
	f->n[kXDim] = ni;
	f->ns[kXDim] = nBC;
	f->ne[kXDim] = nBC+ni;
	f->nt[kXDim] = nBC+nBC+ni;
	f->x = NULL;  // get an axis from an owning grid
	
	f->n[kYDim] = nj;
	f->ns[kYDim] = nBC;
	f->ne[kYDim] = nBC+nj;
	f->nt[kYDim] = nBC+nBC+nj;
	f->y = NULL;  // get an axis from an owning grid
		
	f->xi = (Var2**) zlsAlloc2DArr(sizeof(Var2), (Counter)f->nt[kYDim], (Counter)f->nt[kXDim]);

	if (f->xi == NULL) {
		err = memErr;
	}
	
	return(err);
}

int zlsh_NewF3DArr(F3DArr *f, Integer nBC, Counter nk, Counter nj, Counter ni){
	
	int err = noErr;
	
	f->n[kXDim] = ni;
	f->ns[kXDim] = nBC;
	f->ne[kXDim] = nBC+ni;
	f->nt[kXDim] = nBC+nBC+ni;
	f->x = NULL;  // get an axis from an owning grid
	f->n[kYDim] = nj;
	f->ns[kYDim] = nBC;
	f->ne[kYDim] = nBC+nj;
	f->nt[kYDim] = nBC+nBC+nj;
	f->y = NULL;  // get an axis from an owning grid
	f->n[kZDim] = nk;
	f->ns[kZDim] = nBC;
	f->ne[kZDim] = nBC+nk;
	f->nt[kZDim] = nBC+nBC+nk;
	f->z = NULL;  // get an axis from an owning grid

	f->xi = (Var3***) zlsAlloc3DArr(sizeof(Var3), (Counter)f->nt[kZDim], (Counter)f->nt[kYDim], (Counter)f->nt[kXDim]);
  
	if (f->xi == NULL) {
		err = memErr;
	}
	
	return(err);
}

int zlsh_DisposeF1DArr  (F1DArr f){
	int err = noErr;
	
	if (f.xi !=NULL) free((void *)f.xi); f.xi = NULL;

	return(err);
}

int zlsh_DisposeF2DArr  (F2DArr f){
	int err = noErr;
	
	if (f.xi !=NULL) zlsFree2DArr((void **)f.xi); f.xi = NULL;
	
	return(err);
}

int zlsh_DisposeF3DArr  (F3DArr f){
	int err = noErr;
	if (f.xi !=NULL) zlsFree3DArr((void ***)f.xi); f.xi = NULL;
	return(err);
}

//
// Create w, and prefetch zoneW before calling this routine. 
// Possibly call a GetZone2DW1DX routine first to make w.
// or build one manually.
//
// Then repeated calls to Fill routines will be faster than recreating 
// w and zoneW each call.
#ifdef SYM1D

int zlsh_FillW1DFrom1DZoneWHD (W1DArr w,  WHD zoneW){
#ifndef SYM1D
#pragma unused( w, zoneW)
  return(dimErr);
#else
  //
  // Copy a row from zoneW into w.This routine handles
  // dimensions and BCs.
  //
  //
  // Assumes everything is set up properly first, v. little error checking here
  // as it is a v. low level and hopefully quick routine
  //
	
  int err = noErr;
	
  register Integer i;
  register Real    a0, a1, a2, a3;
  register Integer nti;
  
  nti = w.nt; // assumes w is set up correctly from the owning zone.
    for(i = 0; i<nti; i+=4){// copy whole row including bcs
      a0 = zoneW.d[i];
      a1 = zoneW.d[i+1];
      a2 = zoneW.d[i+2];
      a3 = zoneW.d[i+3];
      w.d[i].a   = a0;
      w.d[i+1].a = a1;
      w.d[i+2].a = a2;
      w.d[i+3].a = a3;
    }
    for(i = 0; i<nti; i+=4){// copy whole row including bcs
      a0 = zoneW.P[i];
      a1 = zoneW.P[i+1];
      a2 = zoneW.P[i+2];
      a3 = zoneW.P[i+3];
      w.P[i].a   = a0;
      w.P[i+1].a = a1;
      w.P[i+2].a = a2;
      w.P[i+3].a = a3;
    }
    for(i = 0; i<nti; i+=4){// copy whole row including bcs
      a0 = zoneW.vx[i];
      a1 = zoneW.vx[i+1];
      a2 = zoneW.vx[i+2];
      a3 = zoneW.vx[i+3];
      w.vx[i].a   = a0;
      w.vx[i+1].a = a1;
      w.vx[i+2].a = a2;
      w.vx[i+3].a = a3;
    }
#if (NTRACERS > 0)    
    register Integer k;
    for (k = 0; k < kNTracers; k++){
      for(i = 0; i<nti; i+=4){// copy whole row including bcs
        a0 = zoneW.tr[k][i];
        a1 = zoneW.tr[k][i+1];
        a2 = zoneW.tr[k][i+2];
        a3 = zoneW.tr[k][i+3];
        w.tr[k][i].a   = a0;
        w.tr[k][i+1].a = a1;
        w.tr[k][i+2].a = a2;
        w.tr[k][i+3].a = a3;
      }
    }
#endif
    
    err = zlsp_CalcEnergyW1D(w); // set up E 
		
    return(err);
#endif
}

// put back a row from a x sweep
int zlsh_Fill1DZoneWHDFromW1D ( WHD zoneW, W1DArr w ) {
#ifndef SYM1D
#pragma unused( w, zoneW)
  return(dimErr);
#else
  //
  // Copy a row from w back into zoneW.This routine handles
  // dimensions and BCs.
  //
  // Assumes everything is set up properly first, v. little error checkeing here
  // as it is a v. low level and hopefully quick routine
  //
	
  int err = noErr;
	
  Integer i;
	
  for(i = kZLS_LimitReplaceLimits; i<w.nt-kZLS_LimitReplaceLimits; i++){// copy whole row that has been remapped
    
#ifdef ACTIVE_FP_NOISE_CONTROL 
    
    register Real a  =  w.d [i].a;
    a   -= zoneW.d [i];
    zoneW.d[i] += zls_tolx( a , kZLS_Small);
    
	  a    = w.P[i].a;
	  a   -= zoneW.P[i];
    zoneW.P[i] += zls_tolx( a , kZLS_Small);
    
	  a    = w.vx[i].a;
	  a   -= zoneW.vx[i];
    zoneW.vx[i] += zls_tolx( a , kZLS_Small);
        
#else
    
    zoneW.d [i] = w.d [i].a;
    zoneW.P [i] = w.P [i].a;
    zoneW.vx[i] = w.vx[i].a;
    
#endif !ACTIVE_FP_NOISE_CONTROL
		
#if (NTRACERS > 0)    
    Integer l;
    for ( l = 0; l < kNTracers; l++ ){
      zoneW.tr[l][i] = w.tr[l][i].a;
    }
#endif
  }
	
  return(err);
#endif SYM1D
}

int zlsh_FillW1DDivVFrom1DZone (W1DArr w,  ZonePtr z){
#ifndef SYM1D
  return(dimErr);
#else
  int err = noErr;
#ifdef DIVVHCORRECTION
  register Integer i;
  register Integer nti;
  nti = w.nt; // assumes w is set up correctly from the owning zone.
  for(i = 0; i<nti; i++){// copy whole row including bcs
    w.divv[i] = z->zoneDivV[i].a;
  }
#endif DIVVHCORRECTION
  return(err);
#endif SYM1D
}

#endif SYM1D


#ifdef SYM2D
//
//
int zlsh_FillW1DFrom2DZoneWHDX (W1DArr w,  WHD zoneW, Integer j){
#ifndef SYM2D
  return(dimErr);
#else
  //
  // Copy a row from zoneW into w.This routine handles
  // dimensions and BCs.
  //
  //
  // Assumes everything is set up properly first, v. little error checking here
  // as it is a v. low level and hopefully quick routine
  //
	
  int err = noErr;
	
  register Integer i;
  register Real    a;
  register Integer nti;
  
  nti = w.nt; // assumes w is set up correctly from the owning zone.
    
    for(i = 0; i<nti; i++){// copy whole row including bcs
			
      a =  zoneW.d[j][i];
      w.d[i].a     = a;

      a  = zoneW.P[j][i];
      w.P[i].a     = a;
			
      a  = zoneW.vx[j][i];
      w.vx[i].a     = a;
			
      a  = zoneW.vy[j][i];
      w.vy[i].a     = a;
      			
#if (NTRACERS > 0)    
      Integer k;
      for (k = 0; k < kNTracers; k++){
        a  = zoneW.tr[k][j][i];
        w.tr[k][i].a     = a;
      }
#endif
    }
    
    err = zlsp_CalcEnergyW1D(w); // set up E 
		
    return(err);
#endif
}

//
int zlsh_FillW1DFrom2DZoneWHDY (W1DArr w,  WHD zoneW, Integer i){
#ifndef SYM2D
  return(dimErr);
#else
  //
  // Copy a row from zoneW into w.This routine handles
  // dimensions and BCs.
  //
  //
  // Assumes everything is set up properly first, v. little error checking here
  // as it is a v. low level and hopefully quick routine
  //
  int err = noErr;
  register Integer j;
  register Real a;
  register Integer ntj;

  ntj = w.nt; // assumes w is set up correctly from the owning zone.
	
  for(j = 0; j<ntj; j++){// copy whole row including bcs
		
    a =  zoneW.d[j][i];
    w.d[j].a     = a;

    a  = zoneW.P[j][i];
    w.P[j].a     = a;

    a  = zoneW.vy[j][i]; // swap x y for y sweep
    w.vx[j].a     = a;
		
    a  = zoneW.vx[j][i];
    w.vy[j].a     = a;
                          
#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      a  = zoneW.tr[k][j][i];
      w.tr[k][j].a     = a;
      }
#endif
  }
  
  err = zlsp_CalcEnergyW1D(w); // set up E 
	
  return(err);
#endif
}

//
int zlsh_Fill2DZoneWHDFromW1DX (WHD zoneW,  W1DArr w,  Integer j ){
#ifndef SYM2D
  return(dimErr);
#else
  //
  // Copy a row from w back into zoneW.
  //
  // Assumes everything is set up properly first, v. little error checking here
  // as it is a v. low level and hopefully quick routine
  //
	
  int err = noErr;
	
  register Integer i;	
  for(i = kZLS_LimitReplaceLimits; i<w.nt-kZLS_LimitReplaceLimits; i++){// copy whole row except bcs

    
#ifdef ACTIVE_FP_NOISE_CONTROL   
    register Real a   = w.d [i].a;
    a   -= zoneW.d [j][i];
    zoneW.d[j][i] += zls_tolx( a , kZLS_Small);
    a    = w.P[i].a;
    a   -= zoneW.P [j][i];
    zoneW.P[j][i] += zls_tolx( a , kZLS_Small);

    a    = w.vx[i].a;
    a   -= zoneW.vx[j][i];
    zoneW.vx[j][i] += zls_tolx( a , kZLS_Small);
    a    = w.vy[i].a;
    a   -= zoneW.vy[j][i];
    zoneW.vy[j][i] += zls_tolx( a , kZLS_Small);
#else
    
    zoneW.d [j][i] = w.d [i].a;
    zoneW.P [j][i] = w.P [i].a;
    zoneW.vx[j][i] = w.vx[i].a;
    zoneW.vy[j][i] = w.vy[i].a;

#endif !ACTIVE_FP_NOISE_CONTROL

#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      zoneW.tr[k][j][i] = w.tr[k][i].a;
    }
#endif
    
  }
	
  return(err);
#endif SYM2D
}


int zlsh_Fill2DZoneWHDFromW1DY (WHD zoneW,  W1DArr w,  Integer i){
#ifndef SYM2D
  return(dimErr);
#else
  //
  // Copy a row from zoneW into w.This routine handles
  // dimensions and BCs.
  //
  //
  // Assumes everything is set up properly first, v. little error checking here
  // as it is a v. low level and hopefully quick routine
  //
  int err = noErr;
  register Integer j;
	
  for(j = kZLS_LimitReplaceLimits; j<w.nt-kZLS_LimitReplaceLimits; j++){
		
    
#ifdef ACTIVE_FP_NOISE_CONTROL   
    register Real a   = w.d [j].a;
    a   -= zoneW.d [j][i];
    zoneW.d[j][i] += zls_tolx( a , kZLS_Small);
    a    = w.P[j].a;
    a   -= zoneW.P [j][i];
    zoneW.P[j][i] += zls_tolx( a , kZLS_Small);

    a    = w.vx[j].a;
    a   -= zoneW.vy[j][i];
    zoneW.vy[j][i] += zls_tolx( a , kZLS_Small);
    a    = w.vy[j].a;
    a   -= zoneW.vx[j][i];
    zoneW.vx[j][i] += zls_tolx( a , kZLS_Small);
#else
    
    zoneW.d [j][i] = w.d [j].a;
    zoneW.P [j][i] = w.P [j].a;
    zoneW.vy[j][i] = w.vx[j].a;
    zoneW.vx[j][i] = w.vy[j].a;


#endif !ACTIVE_FP_NOISE_CONTROL

#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
     zoneW.tr[k][j][i] =  w.tr[k][j].a;
    }
#endif
    
  }
  
  return(err);
	
#endif SYM2D
}

int zlsh_GetZone2DW1DX (W1DArr *w, ZonePtr z, Integer j){
#ifndef SYM2D
  return(dimErr);
#else
	
  int err = noErr;
  W1DArr tempW;
  WHD    zoneW;
  Integer i,ni, nbc;
  Integer nti;
	
  if (z != NULL) {
		
    ni  = z->zoneGrid.n[kXDim];
    nbc = z->zoneGrid.nG;
    err = zlsh_NewW1DArr(&tempW, nbc, (Counter)ni);
    if ( err == noErr ){		
      
      nti = z->zoneGrid.n[kXDim];
			
      tempW.x = z->zoneGrid.x;
			
      err = zls_GetZoneWHD(&zoneW, z);
			
      if (err == noErr) {		
				
        for(i = 0; i<nti; i++){// copy whole row including bcs
					
          tempW.d[i].a  =  zoneW.d[j][i];
          tempW.P[i].a  =  zoneW.P[j][i];
          tempW.vx[i].a = zoneW.vx[j][i];
          tempW.vy[i].a = zoneW.vy[j][i];
          
#if (NTRACERS > 0)    
          Integer k;
          for (k = 0; k < kNTracers; k++){
            tempW.tr[k][i].a = zoneW.tr[k][j][i];
          }
#endif

        }
				
      }
    } else { err = memErr;}// tempW err
		
  } else { err = zonErr;}
	
  *w = tempW;
	
  return(err);
#endif SYM2D
}
//
int zlsh_GetZone2DW1DY (W1DArr *w, ZonePtr z, Integer i){
#ifndef SYM2D
  return(dimErr);
#else
	
  int err = noErr;
  W1DArr tempW;
  WHD    zoneW;
  Integer j, nj, nbc;
  Integer ntj;
	
  if (z != NULL) {
		
    nj  = z->zoneGrid.n[kYDim];
    nbc = z->zoneGrid.nG;
    err =  zlsh_NewW1DArr(&tempW, nbc, (Counter)nj);
		
    if (err == noErr) {
      
      ntj     = z->zoneGrid.n[kYDim];
      tempW.x = z->zoneGrid.y;
      err     = zls_GetZoneWHD(&zoneW, z);
			
      if (err == noErr) {		
				
        for(j = 0; j<ntj; j++){// copy whole row including bcs
					
          tempW.d[j].a  =  zoneW.d[j][i];
          tempW.P[j].a  =  zoneW.P[j][i];
          tempW.vx[j].a = zoneW.vx[j][i];
          tempW.vy[j].a = zoneW.vy[j][i];
#if (NTRACERS > 0)    
          Integer k;
          for (k = 0; k < kNTracers; k++){
            tempW.tr[k][j].a = zoneW.tr[k][j][i];
          }
#endif

        }
				
      }
      
    } // tempW
		
  } else { err = zonErr;}
	
  *w = tempW;
	
  return(err);
#endif SYM2D
}


//
int zlsh_FillW1DDivVFrom2DZoneX ( W1DArr w,  ZonePtr z, Integer j){
#ifndef SYM2D
  return(dimErr);
#else
  int err = noErr;
#ifdef DIVVHCORRECTION
  register Integer i;
  register Integer nti;
  nti = w.nt; // assumes u is set up correctly from the owning zone.
  for(i = 0; i<nti; i++){// copy whole row including bcs
    w.divv[i] = z->zoneDivV[j][i].a[kYDim];  // orthogonal component
  }
#endif DIVVHCORRECTION
  return(err);
#endif
}

//
int zlsh_FillW1DDivVFrom2DZoneY ( W1DArr w,  ZonePtr z, Integer i){
#ifndef SYM2D
  return(dimErr);
#else
  int err = noErr;
#ifdef DIVVHCORRECTION
  register Integer j;
  register Integer ntj;
  
  ntj = w.nt; // assumes u is set up correctly from the owning zone.
  for(j = 0; j<ntj; j++){
    w.divv[j] = z->zoneDivV[j][i].a[kXDim]; // orthogonal component
  }
#endif DIVVHCORRECTION
  return(err);
#endif
}


#endif SYM2D

#ifdef SYM3D
// get a row for an x-sweep
int zlsh_FillW1DXFrom3DZoneWHDYZ (W1DArr w,  WHD zoneW, Integer j, Integer k){
#ifndef SYM3D
  return(dimErr);
#else
  //
  //
  int err = noErr;
  Integer i;
  Real a;
  
  Integer nti = w.nt; // assumes w is set up correctly from the owning zone.
	
  for(i = 0; i<nti; i++){// copy whole row including bcs
		
    a =  zoneW.d[k][j][i];
    w.d[i].a     = a;
		
    a  = zoneW.P[k][j][i];
    w.P[i].a     = a;
		
    a  = zoneW.vx[k][j][i];
    w.vx[i].a    = a;
		
    a  = zoneW.vy[k][j][i];
    w.vy[i].a    = a;
		
    a  = zoneW.vz[k][j][i];
    w.vz[i].a    = a;
		
#if (NTRACERS > 0)    
    Integer l;
    for (l = 0; l < kNTracers; l++){
      a  = zoneW.tr[l][k][j][i];
      w.tr[l][i].a     = a;
    }
#endif
  }
  
  err = zlsp_CalcEnergyW1D(w); // set up E 
	
  return(err);
#endif
}

// get a row for a y-sweep

int zlsh_FillW1DYFrom3DZoneWHDZX (W1DArr w,  WHD zoneW, Integer k, Integer i){
#ifndef SYM3D
  return(dimErr);
#else
  //
  //
  int err = noErr;
  Integer j;
  Real a;
	
  Integer ntj  = w.nt; // assumes w is set up correctly from the owning zone.
	
  for(j = 0; j<ntj; j++){// copy whole row including bcs
		
    a =  zoneW.d[k][j][i];
    w.d[j].a     = a;
		
    a  = zoneW.P[k][j][i];
    w.P[j].a     = a;
		
    a  = zoneW.vy[k][j][i]; // permute velocity vector, right handed system  y sweep y -> x, z -> y, x -> z
    w.vx[j].a    = a;
		
    a  = zoneW.vz[k][j][i];
    w.vy[j].a    = a;
		
    a  = zoneW.vx[k][j][i];
    w.vz[j].a    = a;
		    
#if (NTRACERS > 0)    
    Integer l;
    for (l = 0; l < kNTracers; l++){
      a  = zoneW.tr[l][k][j][i];
      w.tr[l][j].a     = a;
    }
#endif
  }
  
  err = zlsp_CalcEnergyW1D(w); // set up E 
	
  return(err);
#endif
}

// get a row for a z-sweep
int zlsh_FillW1DZFrom3DZoneWHDXY (W1DArr w,  WHD zoneW, Integer i, Integer j){
#ifndef SYM3D
  return(dimErr);
#else
  //
  //
  int err = noErr;
  Integer k;
  Real a;
	
  Integer ntk = w.nt; // assumes w is set up correctly from the owning zone.
	
  for(k = 0; k<ntk; k++){// copy whole row including bcs
		
    a =  zoneW.d[k][j][i];
    w.d[k].a    = a;
		
    a  = zoneW.P[k][j][i];
    w.P[k].a    = a;
		
    a  = zoneW.vz[k][j][i]; // permute velocity vector, right handed system  z sweep z -> x, x -> y, y -> z
    w.vx[k].a    = a;
		
    a  = zoneW.vx[k][j][i];
    w.vy[k].a    = a;
		
    a  = zoneW.vy[k][j][i];
    w.vz[k].a    = a;
						
#if (NTRACERS > 0)    
    Integer l;
    for (l = 0; l < kNTracers; l++){
      a  = zoneW.tr[l][k][j][i];
      w.tr[l][k].a     = a;
    }
#endif
  }
  
  err = zlsp_CalcEnergyW1D(w); // set up E 
	
  return(err);
#endif
}

// put back a row from a x sweep
int zlsh_Fill3DZoneWHDYZFromW1DX ( WHD zoneW, W1DArr w, Integer j, Integer k) {
#ifndef SYM3D
  return(dimErr);
#else
  //
  // Copy a row from w back into zoneW.This routine handles
  // dimensions and BCs.
  //
  // Assumes everything is set up properly first, v. little error checkeing here
  // as it is a v. low level and hopefully quick routine
  //
	
  int err = noErr;
	
  Integer i;
	
  for(i = kZLS_LimitReplaceLimits; i<w.nt-kZLS_LimitReplaceLimits; i++){// copy whole row that has been remapped

#ifdef ACTIVE_FP_NOISE_CONTROL 
  
    register Real a  =  w.d [i].a;
    a   -= zoneW.d [k][j][i];
    zoneW.d[k][j][i] += zls_tolx( a , kZLS_Small);
    
	  a    = w.P[i].a;
	  a   -= zoneW.P[k][j][i];
    zoneW.P[k][j][i] += zls_tolx( a , kZLS_Small);

	  a    = w.vx[i].a;
	  a   -= zoneW.vx[k][j][i];
    zoneW.vx[k][j][i] += zls_tolx( a , kZLS_Small);
    
    a    = w.vy[i].a;
    a   -= zoneW.vy[k][j][i];
    zoneW.vy[k][j][i] += zls_tolx( a , kZLS_Small);
    
    a    = w.vz[i].a;
    a   -= zoneW.vz[k][j][i];
    zoneW.vz[k][j][i] += zls_tolx( a , kZLS_Small);  
	 
#else

    zoneW.d [k][j][i] = w.d [i].a;
    zoneW.P [k][j][i] = w.P [i].a;
    zoneW.vx[k][j][i] = w.vx[i].a;
    zoneW.vy[k][j][i] = w.vy[i].a;
    zoneW.vz[k][j][i] = w.vz[i].a;
    
#endif !ACTIVE_FP_NOISE_CONTROL
		
#if (NTRACERS > 0)    
    Integer l;
    for ( l = 0; l < kNTracers; l++ ){
      zoneW.tr[l][k][j][i] = w.tr[l][i].a;
    }
#endif
  }
	
  return(err);
#endif SYM3D
}

// put back a row from a y sweep
int zlsh_Fill3DZoneWHDZXFromW1DY ( WHD zoneW, W1DArr w, Integer k, Integer i){
#ifndef SYM3D
  return(dimErr);
#else
  //
  // Copy a row from zoneW into w.This routine handles
  // dimensions and BCs.
  //
  //
  // Assumes everything is set up properly first, v. little error checkeing here
  // as it is a v. low level and hopefully quick routine
  //
  int err = noErr;
  Integer j;
	
  // unpermute velocity vector, right handed system end of y sweep x -> y, y -> z, z -> x
  
  for(j = kZLS_LimitReplaceLimits; j<w.nt-kZLS_LimitReplaceLimits; j++){// copy whole row that has evolved
    
#ifdef ACTIVE_FP_NOISE_CONTROL   
    register Real a    = w.d [j].a;
    a   -= zoneW.d [k][j][i];
    zoneW.d[k][j][i] += zls_tolx( a , kZLS_Small);
	  a    = w.P[j].a;
	  a   -= zoneW.P[k][j][i];
    zoneW.P[k][j][i] += zls_tolx( a , kZLS_Small);
    
	  a    = w.vx[j].a;
    a   -= zoneW.vy[k][j][i];
    zoneW.vy[k][j][i] += zls_tolx( a , kZLS_Small);
	  a    = w.vy[j].a;
	  a   -= zoneW.vz[k][j][i];
    zoneW.vz[k][j][i] += zls_tolx( a , kZLS_Small);
	  a   = w.vz[j].a;
	  a  -= zoneW.vx[k][j][i];
    zoneW.vx[k][j][i] += zls_tolx( a , kZLS_Small);

#else
    
    zoneW.d [k][j][i] = w.d [j].a;
    zoneW.P [k][j][i] = w.P [j].a;
    zoneW.vy[k][j][i] = w.vx[j].a;
    zoneW.vz[k][j][i] = w.vy[j].a;
    zoneW.vx[k][j][i] = w.vz[j].a;

#endif !ACTIVE_FP_NOISE_CONTROL
    
#if (NTRACERS > 0)    
    Integer l;
    for ( l = 0; l < kNTracers; l++){
      zoneW.tr[l][k][j][i] = w.tr[l][j].a;
    }
#endif
  }
	
  return(err);
	
#endif SYM3D
}


int zlsh_Fill3DZoneWHDXYFromW1DZ ( WHD zoneW, W1DArr w, Integer i, Integer j){
#ifndef SYM3D
  return(dimErr);
#else
  //
  // Copy a row from zoneW into w.This routine handles
  // dimensions and BCs.
  //
  //
  // Assumes everything is set up properly first, v. little error checking here
  // as it is a v. low level and hopefully quick routine
  //
  int err = noErr;
  Integer k;
  
  // unpermute velocity vector, right handed system  z sweep x -> z, y -> x, z -> y
	
  for(k = kZLS_LimitReplaceLimits; k<w.nt-kZLS_LimitReplaceLimits; k++){// copy whole row that has remapped

#ifdef ACTIVE_FP_NOISE_CONTROL   
    
    register Real a   = w.d [k].a;
    a   -= zoneW.d [k][j][i];
    zoneW.d[k][j][i] += zls_tolx( a , kZLS_Small);
	
	  a    = w.P[k].a;
	  a   -= zoneW.P[k][j][i];
    zoneW.P[k][j][i] += zls_tolx( a , kZLS_Small);

    a    = w.vx[k].a;
    a   -= zoneW.vz[k][j][i];
    zoneW.vz[k][j][i] += zls_tolx( a , kZLS_Small);
	
    a    = w.vy[k].a;
    a   -= zoneW.vx[k][j][i];
    zoneW.vx[k][j][i] += zls_tolx( a , kZLS_Small);
	
    a    = w.vz[k].a;
    a   -= zoneW.vy[k][j][i];
    zoneW.vy[k][j][i] += zls_tolx( a , kZLS_Small);
    
#else
    
    zoneW.d [k][j][i] = w.d [k].a;
    zoneW.P [k][j][i] = w.P [k].a;
    zoneW.vz[k][j][i] = w.vx[k].a;
    zoneW.vx[k][j][i] = w.vy[k].a;
    zoneW.vy[k][j][i] = w.vz[k].a;
    
#endif !ACTIVE_FP_NOISE_CONTROL

#if (NTRACERS > 0)    
    Integer l;
    for ( l = 0; l < kNTracers; l++){
      zoneW.tr[l][k][j][i] = w.tr[l][k].a;
    }
#endif
  }
	
  return(err);
	
#endif SYM3D
}

int zlsh_GetZone3DW1DX (W1DArr *w, ZonePtr z, Integer j, Integer k){
  int err = nyiErr;
#if (ZLS_DEBUG>0)	
  zlsio_ErrPrintf( " Not Yet Implemented: GetZone3DW1DX\n" );
#endif	
  return(err);
}

int zlsh_GetZone3DW1DY (W1DArr *w, ZonePtr z, Integer k, Integer i){
  int err = nyiErr;
#if (ZLS_DEBUG>0)	
  zlsio_ErrPrintf( " Not Yet Implemented: GetZone3DW1DY\n" );
#endif	
  return(err);
}
int zlsh_GetZone3DW1DZ (W1DArr *w, ZonePtr z, Integer i, Integer j){
  int err = nyiErr;
#if (ZLS_DEBUG>0)	
  zlsio_ErrPrintf( " Not Yet Implemented: GetZone3DW1DZ\n" );
#endif	
  return(err);
}


//
int zlsh_FillW1DDivVFrom3DZoneYZ (W1DArr w,  ZonePtr z, Integer j, Integer k){
#ifndef SYM3D
  return(dimErr);
#else
  int err = noErr;
#ifdef DIVVHCORRECTION
  register Integer i;
  register Integer nti;
  nti = w.nt; // assumes w is set up correctly from the owning zone.
  for(i = 0; i<nti; i++){// copy whole row including bcs
    w.divv[i]  = z->zoneDivV[k][j][i].a[kYDim];  // orthogonal component
    w.divv[i] += z->zoneDivV[k][j][i].a[kZDim];  // orthogonal component
  }
#endif DIVVHCORRECTION
  return(err);
#endif
}

//
int zlsh_FillW1DDivVFrom3DZoneZX (W1DArr w,  ZonePtr z, Integer k, Integer i){
#ifndef SYM3D
  return(dimErr);
#else
  int err = noErr;
#ifdef DIVVHCORRECTION
  register Integer j;
  register Integer ntj;
  
  ntj = w.nt; // assumes w is set up correctly from the owning zone.
  for(j = 0; j<ntj; j++){
    w.divv[j]  = z->zoneDivV[k][j][i].a[kXDim];  // orthogonal component
    w.divv[j] += z->zoneDivV[k][j][i].a[kZDim];  // orthogonal component
  }
#endif DIVVHCORRECTION
  return(err);
#endif
}


//
int zlsh_FillW1DDivVFrom3DZoneXY (W1DArr w,  ZonePtr z, Integer i, Integer j){
#ifndef SYM3D
  return(dimErr);
#else
  int err = noErr;
#ifdef DIVVHCORRECTION
  register Integer k;
  register Integer ntk;
  
  ntk = w.nt; // assumes w is set up correctly from the owning zone.
  for(k = 0; k<ntk; k++){
    w.divv[k]  = z->zoneDivV[k][j][i].a[kXDim];  // orthogonal component
    w.divv[k] += z->zoneDivV[k][j][i].a[kYDim];  // orthogonal component
  }
  
#endif DIVVHCORRECTION
  return(err);
#endif
}

#endif SYM3D

//========================================
// fluxes - hydro components for each direction, assumed for lower (left) boundary of the cell
//========================================

int zlsh_NewWFluxes1DArr       (Flx1DArr *fx, Integer nBC, Counter ni){
	
	int err = noErr;
	
	fx->n = ni;
	fx->ns = nBC;
	fx->ne = nBC+ni;
	fx->nt = nBC+nBC+ni;
	
	fx->f = (WFlux1 *) malloc((nBC+nBC+ni)*sizeof(WFlux1));
	
	if (fx->f == NULL) {
		err = memErr;
	}
	
	return(err);
}

int zlsh_NewWFluxes2DArr (Flx2DArr *fx, Integer nBC, Counter nj, Counter ni){
	
	int err = noErr;
	
	fx->n[kXDim] = ni;
	fx->ns[kXDim] = nBC;
	fx->ne[kXDim] = nBC+ni;
	fx->nt[kXDim] = nBC+nBC+ni;
	
	fx->n[kYDim] = nj;
	fx->ns[kYDim] = nBC;
	fx->ne[kYDim] = nBC+nj;
	fx->nt[kYDim] = nBC+nBC+nj;
	
	fx->f = (WFlux2**) zlsAlloc2DArr(sizeof(WFlux2), (Counter)fx->nt[kYDim], (Counter)fx->nt[kXDim]);
	
	if (fx->f == NULL) {
		err = memErr;
	}
	
	
	return(err);
}

int zlsh_NewWFluxes3DArr (Flx3DArr *fx,Integer nBC, Counter nk, Counter nj, Counter ni){
	
	int err = noErr;
	
	fx->n[kXDim] = ni;
	fx->ns[kXDim] = nBC;
	fx->ne[kXDim] = nBC+ni;
	fx->nt[kXDim] = nBC+nBC+ni;
	
	fx->n[kYDim] = nj;
	fx->ns[kYDim] = nBC;
	fx->ne[kYDim] = nBC+nj;
	fx->nt[kYDim] = nBC+nBC+nj;
	
	fx->n[kZDim] = nk;
	fx->ns[kZDim] = nBC;
	fx->ne[kZDim] = nBC+nk;
	fx->nt[kZDim] = nBC+nBC+nk;
	
	fx->f = (WFlux3***) zlsAlloc3DArr(sizeof(WFlux3), (Counter)fx->nt[kZDim], (Counter)fx->nt[kYDim], (Counter)fx->nt[kXDim]);
	
	if (fx->f == NULL) {
		err = memErr;
	}
	
	return(err);
}


int zlsh_ClearWFluxes1DArr       (Flx1DArr fx){
	
	int err = noErr;
	Counter n = fx.nt;
	
	if (fx.f != NULL){
		bzero((void *)fx.f, n*sizeof(WFlux1));
	} else  {
		err = memErr;
	}
	
	return(err);
}

int zlsh_ClearWFluxes2DArr (Flx2DArr fx){
	
	int err = noErr;
	
	if (fx.f != NULL){
		zlsZero2DArr((void **)fx.f,  sizeof(WFlux2),  fx.nt[kYDim],  fx.nt[kXDim]);
	} else  {
		err = memErr;
	}
	
	return(err);
}

int zlsh_ClearWFluxes3DArr (Flx3DArr fx){
	
	int err = noErr;
	
	if (fx.f != NULL){
		zlsZero3DArr((void ***)fx.f,  sizeof(WFlux3),  fx.nt[kZDim], fx.nt[kYDim],  fx.nt[kXDim]);
	} else  {
		err = memErr;
	}
	
	return(err);
}

int zlsh_DisposeWFluxes1DArr   (Flx1DArr fx){
	int err = noErr;
	if (fx.f != NULL) {
		free(fx.f);
	}
	return(err);                 
}

int zlsh_DisposeWFluxes2DArr   (Flx2DArr fx){
	
	int err = noErr;
	if (fx.f !=NULL) zlsFree2DArr((void **)fx.f); fx.f = NULL;
	return(err);
}

int zlsh_DisposeWFluxes3DArr   (Flx3DArr fx){
	
	int err = noErr;
	if (fx.f !=NULL) zlsFree3DArr((void ***)fx.f); fx.f = NULL;
	return(err);
	
}

int zlsh_CopyU1DfromW1D ( U1DArr u, W1DArr w ){
  
  int err = noErr;
  register Integer i;
  register Real   d, dl, dr;
  register Integer nti;
  
  nti = w.nt; // assumes w and u are set up to the same size;
  
  for(i = 0; i<nti; i++){// copy whole row including bcs
    
    d         =  w.d[i].a;
    dl        =  w.d[i].al; dl = dl > 0.0? dl: d;
    dr        =  w.d[i].ar; dr = dr > 0.0? dr: d;
    
    u.d[i].a  =  d;
    u.d[i].al =  dl;
    u.d[i].ar =  dr;
    
    u.P[i].a  = w.P[i].a ;
    u.P[i].al = w.P[i].al;
    u.P[i].ar = w.P[i].ar;
    
#ifdef HYDRO    
#ifdef SYM1D
    u.mx[i].a  = w.vx[i].a *d ;
    u.mx[i].al = w.vx[i].al*dl;
    u.mx[i].ar = w.vx[i].ar*dr;    
#endif SYM1D
#ifdef SYM2D
    u.mx[i].a  = w.vx[i].a *d ;
    u.mx[i].al = w.vx[i].al*dl;
    u.mx[i].ar = w.vx[i].ar*dr;    
    u.my[i].a  = w.vy[i].a *d ;
    u.my[i].al = w.vy[i].al*dl;
    u.my[i].ar = w.vy[i].ar*dr;
#endif SYM2D
#ifdef SYM3D
    u.mx[i].a  = w.vx[i].a *d ;
    u.mx[i].al = w.vx[i].al*dl;
    u.mx[i].ar = w.vx[i].ar*dr;    
    u.my[i].a  = w.vy[i].a *d ;
    u.my[i].al = w.vy[i].al*dl;
    u.my[i].ar = w.vy[i].ar*dr;
    u.mz[i].a  = w.vz[i].a *d ;
    u.mz[i].al = w.vz[i].al*dl;
    u.mz[i].ar = w.vz[i].ar*dr;
#endif SYM3D
#endif HYDRO
    
    u.E[i].a  = zlsp_EFromP_W1D ( w, i);
    u.E[i].al = zlsp_EFromP_W1DL( w, i);
    u.E[i].ar = zlsp_EFromP_W1DR( w, i);
    
#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      u.tr[k][i].a     = w.tr[k][i].a ;
      u.tr[k][i].al    = w.tr[k][i].al;
      u.tr[k][i].ar    = w.tr[k][i].ar;
    }
#endif
  }
	
  return(err);
  
}

int zlsh_CopyU1DLRfromW1DLR ( U1DArr u, W1DArr w ){
  
  int err = noErr;
  register Integer i;
  register Real    d, dl, dr;
  register Integer nti;
  
  nti = w.nt; // assumes w and u are set up to the same size;
  
  for(i = 0; i<nti; i++){// copy whole row including bcs
    
    d         =  w.d[i].a;
    dl        =  w.d[i].al; dl = dl > 0.0? dl: d;
    dr        =  w.d[i].ar; dr = dr > 0.0? dr: d;
    
    u.d[i].al =  dl;
    u.d[i].ar =  dr;
    
    u.P[i].al = w.P[i].al;
    u.P[i].ar = w.P[i].ar;
    
#ifdef HYDRO    
#ifdef SYM1D
    u.mx[i].al = w.vx[i].al*dl;
    u.mx[i].ar = w.vx[i].ar*dr;    
#endif SYM1D
#ifdef SYM2D
    u.mx[i].al = w.vx[i].al*dl;
    u.mx[i].ar = w.vx[i].ar*dr;    
    u.my[i].al = w.vy[i].al*dl;
    u.my[i].ar = w.vy[i].ar*dr;
#endif SYM2D
#ifdef SYM3D
    u.mx[i].al = w.vx[i].al*dl;
    u.mx[i].ar = w.vx[i].ar*dr;    
    u.my[i].al = w.vy[i].al*dl;
    u.my[i].ar = w.vy[i].ar*dr;
    u.mz[i].al = w.vz[i].al*dl;
    u.mz[i].ar = w.vz[i].ar*dr;
#endif SYM3D
#endif HYDRO
    
#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      u.tr[k][i].al    = w.tr[k][i].al;
      u.tr[k][i].ar    = w.tr[k][i].ar;
    }
#endif

    u.E[i].al = zlsp_EFromP_W1DL( w, i);
    u.E[i].ar = zlsp_EFromP_W1DR( w, i);
    
  }
	
  return(err);
  
}


int zlsh_CopyU1DCfromW1DC ( U1DArr u, W1DArr w ){
  
  int err = noErr;
  register Integer i;
  register Real    d;
  register Integer nti;
  
  nti = w.nt; // assumes w and u are set up to the same size;
  
  for(i = 0; i<nti; i++){// copy whole row including bcs
    
    d         =  w.d[i].a;
    u.d[i].a  =  d;
    u.P[i].a  = w.P[i].a ;

#ifdef HYDRO    
#ifdef SYM1D
    u.mx[i].a  = w.vx[i].a*d;
#endif SYM1D
#ifdef SYM2D
    u.mx[i].a  = w.vx[i].a*d;
    u.my[i].a  = w.vy[i].a*d;
#endif SYM2D
#ifdef SYM3D
    u.mx[i].a  = w.vx[i].a*d;
    u.my[i].a  = w.vy[i].a*d;
    u.mz[i].a  = w.vz[i].a*d;
#endif SYM3D
#endif HYDRO

    u.E[i].a  = zlsp_EFromP_W1D ( w, i);
    
#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      u.tr[k][i].a     = w.tr[k][i].a ;
    }
#endif
  }
	
  return(err);
  
}


int zlsh_CopyW1DfromU1D ( W1DArr w, U1DArr u ){
  
  int err = noErr;
  register Integer i;
  register Real    d, id;
  register Real    dl, idl;
  register Real    dr, idr;
  register Integer nti;
  
  nti = u.nt; // assumes w and u are set up to the same size,and u.P is correct
  
  for(i = 0; i<nti; i++){// copy whole row including bcs
    
    d        =  u.d[i].a ;
    dl       =  u.d[i].al; dl = dl > 0.0? dl: d;
    dr       =  u.d[i].ar; dr = dr > 0.0? dr: d;
    id       = 1.0/d;
    idl      = 1.0/dl;
    idr      = 1.0/dr;
    
    w.d[i].a  = d ;
    w.d[i].al = dl;
    w.d[i].ar = dr;
    
    w.E[i].a  = u.E[i].a ;
    w.E[i].al = u.E[i].al;
    w.E[i].ar = u.E[i].ar;
    
    w.P[i].a  = u.P[i].a ;
    w.P[i].al = u.P[i].al;
    w.P[i].ar = u.P[i].ar;
    
#ifdef HYDRO    
#ifdef SYM1D
    w.vx[i].a  = u.mx[i].a *id ;
    w.vx[i].al = u.mx[i].al*idl;
    w.vx[i].ar = u.mx[i].ar*idr;
#endif SYM1D
#ifdef SYM2D
    w.vx[i].a  = u.mx[i].a *id ;
    w.vx[i].al = u.mx[i].al*idl;
    w.vx[i].ar = u.mx[i].ar*idr;
    
    w.vy[i].a  = u.my[i].a *id ;
    w.vy[i].al = u.my[i].al*idl;
    w.vy[i].ar = u.my[i].ar*idr;
#endif SYM2D
#ifdef SYM3D
    w.vx[i].a  = u.mx[i].a *id ;
    w.vx[i].al = u.mx[i].al*idl;
    w.vx[i].ar = u.mx[i].ar*idr;
    
    w.vy[i].a  = u.my[i].a *id ;
    w.vy[i].al = u.my[i].al*idl;
    w.vy[i].ar = u.my[i].ar*idr;
    
    w.vz[i].a  = u.mz[i].a *id ;
    w.vz[i].al = u.mz[i].al*idl;
    w.vz[i].ar = u.mz[i].ar*idr;
#endif SYM3D
    
#endif HYDRO
    
#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      w.tr[k][i].a     = u.tr[k][i].a ;
      w.tr[k][i].al    = u.tr[k][i].al;
      w.tr[k][i].ar    = u.tr[k][i].ar;
    }
#endif
  }
	
  return(err);
  
}

int zlsh_CopyW1DLRfromU1DLR ( W1DArr w, U1DArr u ){
  
  int err = noErr;
  register Integer i;
  register Real    d;
  register Real    dl, idl;
  register Real    dr, idr;
  register Integer nti;
  
  nti = u.nt; // assumes w and u are set up to the same size,and u.P is correct
  
  for(i = 0; i<nti; i++){// copy whole row including bcs
    
    d        =  u.d[i].a ;
    dl       =  u.d[i].al; dl = dl > 0.0? dl: d;
    dr       =  u.d[i].ar; dr = dr > 0.0? dr: d;

    idl      = 1.0/dl;
    idr      = 1.0/dr;
    
    w.d[i].al = dl;
    w.d[i].ar = dr;
    
    w.E[i].al = u.E[i].al;
    w.E[i].ar = u.E[i].ar;
    
    w.P[i].al = u.P[i].al;
    w.P[i].ar = u.P[i].ar;
    
#ifdef HYDRO    
#ifdef SYM1D
    w.vx[i].al = u.mx[i].al*idl;
    w.vx[i].ar = u.mx[i].ar*idr;
#endif SYM1D
#ifdef SYM2D
    w.vx[i].al = u.mx[i].al*idl;
    w.vx[i].ar = u.mx[i].ar*idr;
    
    w.vy[i].al = u.my[i].al*idl;
    w.vy[i].ar = u.my[i].ar*idr;
#endif SYM2D
#ifdef SYM3D
    w.vx[i].al = u.mx[i].al*idl;
    w.vx[i].ar = u.mx[i].ar*idr;
    
    w.vy[i].al = u.my[i].al*idl;
    w.vy[i].ar = u.my[i].ar*idr;
    
    w.vz[i].al = u.mz[i].al*idl;
    w.vz[i].ar = u.mz[i].ar*idr;
#endif SYM3D
    
#endif HYDRO
        
#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      w.tr[k][i].al    = u.tr[k][i].al;
      w.tr[k][i].ar    = u.tr[k][i].ar;
    }
#endif

  }
	
  return(err);
  
}

int zlsh_CopyW1DCfromU1DC ( W1DArr w, U1DArr u ){
  
  int err = noErr;
  register Integer i;
  register Real    d, id;
  
  register Integer nti;
  
  nti = u.nt; // assumes w and u are set up to the same size,and u.P is correct
  
  for(i = 0; i<nti; i++){// copy whole row including bcs
    
    d        =  u.d[i].a ;
    id       = 1.0/d;
    
    w.d[i].a  = d ;
    
    w.E[i].a  = u.E[i].a ;
    
    w.P[i].a  = u.P[i].a ;
    
#ifdef HYDRO    
#ifdef SYM1D
    w.vx[i].a  = u.mx[i].a *id ;
#endif SYM1D
#ifdef SYM2D
    w.vx[i].a  = u.mx[i].a *id ;
    
    w.vy[i].a  = u.my[i].a *id ;
#endif SYM2D
#ifdef SYM3D
    w.vx[i].a  = u.mx[i].a *id ;
    
    w.vy[i].a  = u.my[i].a *id ;
    
    w.vz[i].a  = u.mz[i].a *id ;
#endif SYM3D
    
#endif HYDRO
        
#if (NTRACERS > 0)    
    Integer k;
    for (k = 0; k < kNTracers; k++){
      w.tr[k][i].a     = u.tr[k][i].a ;
    }
#endif
    
  }
	
  return(err);
  
}

