#ifndef ZLS_IOFITS_H
#define ZLS_IOFITS_H
#include "zls.h"

//============================================================
// Limited FITS file support - produces FITS compatible 
// versions of bdat files, using comments for untranslatable
// components, plus comments contain setup info.
//============================================================

#pragma pack(1)

typedef struct {
  char    key [8]; 
  char        sep;
  char  value[71];
} charline;
#define ZLS_FITS_LINESIZE (sizeof(charline))

#pragma pack()

//========================================
// 32 bit single precision float FITS files, file specified by name
//

int zlsio_Write32BitFloatFITSHeader ( zFile f, ZonePtr z, IOSettingsPtr io, Integer ioIndex  );
int zlsio_Write32BitFloatFITSData   ( zFile fileAccess, float * fq, Counter ni, Counter nj, Counter nk );

int zlsio_Save32BitFloatZoneFITS   ( ZonePtr z, Integer varIndex, Integer level, Integer zone,
                                     IOSettingsPtr  io, Integer ioIndex );

// high level, save a level of zones as separate 32 bit float data
// files, same dims as zones

int zlsio_SaveLevel32BitFloatZoneFITS(Integer level, int step);

#endif ZLS_IOFITS_H
