#ifndef ZLS_PROBLEM_H
#define ZLS_PROBLEM_H
#include <zls.h>


#define FYRIS_PROBLEMNAME "Noh!"
// this identifier is recorded in state dumps so that 
// the reader can cross check consistency of the data. 
// define a new one for each different problem
#define ZLS_USER_BOUNDARIES
//#define ZLS_USER_UPDATE_ROUTINE

#define NOH

// set up a custom text output routine, defined in problem.c
#ifdef SYM1D
#define TEXTOUTPUT(f, z) zlsp_1DNohZoneOutput(f, z)
int zlsp_1DNohZoneOutput( zFile f, ZonePtr z);
#endif SYM1D
#ifdef SYM2D
#define TEXTOUTPUT(f, z) zlsp_2DNohZoneOutput(f, z)
int zlsp_2DNohZoneOutput( zFile f, ZonePtr z);
#endif SYM2D
#ifdef SYM3D
#define TEXTOUTPUT(f, z) zlsp_3DNohZoneOutput(f, z)
int zlsp_3DNohZoneOutput( zFile f, ZonePtr z);
#endif SYM3D


typedef struct prob {
//
// define global problem parameters here.  
// These will be available to all the code
// via the global level[0] structure

  Real gD0;
  Real gP0;
  Real gvMag;
  
} Problem, * ProblemPtr;


int   zlsp_InitProblem    ( ProblemPtr   prob);
int   zlsp_NewProblem     ( ProblemPtr * prob);
int   zlsp_DisposeProblem ( ProblemPtr   prob);

int   zlsp_InitZoneData          ( ZonePtr z );
int   zlsp_InitLevelZones        ( Integer level );

int   zlsp_SetUpProblemFromConfigFile(char * confFile);

#ifdef ZLS_USER_BOUNDARIES
int  zlsp_CalcUserZoneBCs ( ZonePtr z, int direction, int bndryKind );
#endif ZLS_USER_BOUNDARIES

#ifdef ZLS_USER_UPDATE_ROUTINE
int zlsp_UserZoneUpdate( ZonePtr z);
#endif ZLS_USER_UPDATE_ROUTINE


#endif ZLS_PROBLEM_H
