#ifndef ZLS_PROBLEM_H
#define ZLS_PROBLEM_H
#include <zls.h>
//
//  2d classic SOD shock tube problem
//
#define FYRIS_PROBLEMNAME "SOD Shock Tube"
//
//
//#define ZLS_USER_BC_ROUTINE
//#define ZLS_USER_UPDATE_ROUTINE
//
typedef struct prob {
//
// define global problem parameters here.  
// These will be available to all the code
// via the global level[0] structure
//  
// set in user's zls_SetUpProblemFromConfigFile routine
  Real gX0;
  Real gX1;
//  
  Real gP0;
  Real gd0;
  Real gv0;
//  
  Real gP1;
  Real gd1;
  Real gv1;
//  
  Real gP2;
  Real gd2;
  Real gv2;
//  
} Problem, * ProblemPtr;


int   zlsp_InitProblem    ( ProblemPtr   prob);
int   zlsp_NewProblem     ( ProblemPtr * prob);
int   zlsp_DisposeProblem ( ProblemPtr   prob);

int   zlsp_InitZoneData          ( ZonePtr z );
int   zlsp_InitLevelZones        ( Integer level );

int   zlsp_SetUpProblemFromConfigFile(char * confFile);

#ifdef ZLS_USER_BC_ROUTINE
int  zlsp_CalcUserZoneBCs ( ZonePtr z, int direction, int bndryKind );
#endif ZLS_USER_BC_ROUTINE

#ifdef ZLS_USER_UPDATE_ROUTINE
int zlsp_UserZoneUpdate( ZonePtr z);
#endif ZLS_USER_UPDATE_ROUTINE


#endif ZLS_PROBLEM_H